From 21749dfc4e1b51c6c8cd1d49cb233a2afbec765f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 14 2020 23:50:15 +0000
Subject: [PATCH 1383/2232] Fix symlink_or_copy signature on non-unix non-windows


Our other implementations of symlink_or_copy return Result<()> to match
std::os::unix::fs::symlink, but fs::copy returns Result<u64>.

Before:

    $ cargo check --target wasm32-wasi

    error[E0308]: mismatched types
      --> gen/build/src/out.rs:45:12
       |
    43 |     match paths::symlink_or_copy(original, link) {
       |           -------------------------------------- this expression has type `std::result::Result<u64, gen::fs::Error>`
    44 |         // As long as symlink_or_copy succeeded, ignore any create_dir_all error.
    45 |         Ok(()) => Ok(()),
       |            ^^ expected `u64`, found `()`

---

diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index f738f7a..6a8d352 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -58,7 +58,13 @@ pub(crate) fn symlink_or_copy(
 }
 
 #[cfg(not(any(unix, windows)))]
-pub(crate) use self::fs::copy as symlink_or_copy;
+pub(crate) fn symlink_or_copy(
+    original: impl AsRef<Path>,
+    copy: impl AsRef<Path>,
+) -> fs::Result<()> {
+    fs::copy(original, copy)?;
+    Ok(())
+}
 
 #[cfg(any(unix, windows))]
 pub(crate) use self::fs::symlink_dir;

